/*
** recv.c
**
** Made by mycroft (mycroft)
** <mycroft@minithins.net> on virgaria.minithins.net
**
** Started on  Thu Jan  2 11:11:18 2003 mycroft
** Last update Thu Jan  2 11:11:18 2003 mycroft
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "net_api.h"

int main (void)
{
  TTrame Trame;
  TTrame Trame_ACK;

  unsigned short numPaquet = 0;
  unsigned short numPaquetRecu;

  TAddress AS;
  TAddress AD;
  Tampon T;

  net_init ();

  while (1)
  {
    Attendre (SigRecPhy);
    Prendre_de_la_couche_physique (&Trame);
    Effacer (SigRecPhy);

    Recuperer_donnees (&AS, &AD, &T, &numPaquetRecu, Trame);
    printf("Recuperation des donnees OK (%i|%i)\n", 
      numPaquetRecu, numPaquet + 1);

    if (numPaquetRecu == numPaquet + 1)
    {
      numPaquet ++;
      Envoyer_vers_couche_reseau (T, AS, AD);

      /* Construire ack */

      Construire_trame_ACK (AS, AD, T, numPaquetRecu, &Trame_ACK);

      Envoyer_vers_couche_physique (Trame_ACK);
      printf ("ack envoye !\n");
      sleep (2);

      Effacer (SigRec);
    }
    else
    {
      fprintf (stderr, "Rejet trame numero %i\n", numPaquetRecu);
    }
  }

  return (0);
}
