/*
** sender.c
**
** Made by mycroft (mycroft)
** <mycroft@minithins.net> on virgaria.minithins.net
**
** Started on  Wed Jan  1 16:47:10 2003 mycroft
** Last update Wed Jan  1 17:45:06 2003 mycroft
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "net_api.h"

int main (int argn, char **argv)
{
  TAddress AS;
  TAddress AD;
  Tampon donnes;
  Tampon T;

  TTrame Trame;
  unsigned short NotACKTrame[NOMBRE_MEMOIRE];
  TTrame NotACK[NOMBRE_MEMOIRE];

  unsigned short numPaquet = 1;
  unsigned short numPaquetRecu;
  int fin = 0;
  int i;
  int debut = 0;

  donnes.ptr_data = NULL;
  donnes.taille = 0;

  vide_trame_tab (NotACKTrame);

  while (!fin)
  {
    Attendre (SigEmis | SigRecPhy | SigTempo);

    if ( Signale (SigEmis) )
    {
      if (yatildelaplace_trame_tab (NotACKTrame))
      {
        Prendre_de_la_couche_reseau (&AS, &AD, &donnes);
        Effacer (SigEmis);
        Construire_trame (AS, AD, donnes, numPaquet, &Trame);
        Envoyer_vers_couche_physique (Trame);
        copie_trame (&Trame, &NotACK[add_trame_tab (NotACKTrame, numPaquet)]);
        numPaquet ++;
        Tempo ( 10 );
        Effacer (SigEmis);
      }
    }

    if ( Signale (SigTempo) )
    {
      /* On verifie si y a pas des trames en attente d ack. */
      for (i = debut; i < NOMBRE_MEMOIRE; i++)
      {
        /* Y a un bug ici .*/
        /* Fix: non y a plus de bug */
        if (NotACKTrame[i])
        {
          Envoyer_vers_couche_physique (NotACK[i]); 
          fin = 1;      
          break;
          /* le break est la pour quon fasse une boucle pour pas 
             perdre des donnees envoyees */
        }
      }
      if (debut == NOMBRE_MEMOIRE)
        debut = 0;
      Effacer (SigTempo);

      if (fin)
      {
        Tempo ( 10 );
        fin = 0;
      }

    } 

    if ( Signale (SigRecPhy) )
    {
      /* Donnees dans le fichier physique */
      Prendre_de_la_couche_physique (&Trame);
       /* decomp */
      Recuperer_donnees (&AS, &AD, &T, &numPaquetRecu, Trame);
      if (Trame.TYPE != ACK)
      {
        printf ("Hu Ho ... I wasnt supposed to get that.\n");
		Envoyer_vers_couche_physique (Trame);
        sleep (1);
      }
      else
      {
        printf ("ack recu pour %i\n", numPaquetRecu);
        rem_trame_tab (NotACKTrame, numPaquetRecu); 
      }
      Effacer (SigRecPhy);

    }

/*
      else
      {
        fin = 0;
        nbRetransmission = 20;
        Prendre_de_la_couche_physique (&Trame);
        numPaquet ++;
        printf ("ack recu.\n");
        Effacer (SigRecPhy);
      }
    }
    sleep (1);
*/
  }

  fprintf (stderr, "Soucis. Fin.\n");

  return (0);
}
