/*
** sender.c
**
** Made by mycroft (mycroft)
** <mycroft@minithins.net> on virgaria.minithins.net
**
** Started on  Wed Jan  1 16:47:10 2003 mycroft
** Last update Wed Jan  1 17:45:06 2003 mycroft
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "net_api.h"

int main (int argn, char **argv)
{
  TAddress AS;
  TAddress AD;
  Tampon donnes;
  TTrame Trame;
  unsigned short NotACKTrame[NOMBRE_MEMOIRE];

  unsigned short numPaquet = 1;
  int nbRetransmission;
  int fin = 0;

  donnes.ptr_data = NULL;
  donnes.taille = 0;

  while (!fin)
  {
    Attendre (SigEmis);
    Prendre_de_la_couche_reseau (&AS, &AD, &donnes);
    Effacer (SigEmis);
    Construire_trame (AS, AD, donnes, numPaquet, &Trame); 
    Envoyer_vers_couche_physique (Trame);

    nbRetransmission = 0;
    fin = 1;

    Effacer (SigTempo);

    while (nbRetransmission < 10)
    { 
      /* Au cas ou */
      Tempo ( 10 );
      Attendre (SigRecPhy | SigTempo);

      if ( Signale (SigTempo) )
      {
        /* Pas recu d ACK ... donc probleme . */
        nbRetransmission ++;
        Envoyer_vers_couche_physique (Trame);
        Effacer (SigTempo);
      }
      else
      {
        /* SigRecPhy: */
        fin = 0;
        nbRetransmission = 20;
        Prendre_de_la_couche_physique (&Trame);
        numPaquet ++;
        /* Ca doit etre le ack, docn on oublie */
        printf ("ack recu.\n");
        Effacer (SigRecPhy);
      }
    }

    sleep (1);
  }

  fprintf (stderr, "Soucis. Fin.\n");

  return (0);
}
