/*
** appli_to_net.c
**
** Made by mycroft (mycroft)
** <mycroft@minithins.net> on virgaria.minithins.net
**
** Started on  Fri Jan  3 12:14:26 2003 mycroft
** Last update Fri Jan  3 12:14:26 2003 mycroft
*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>

#include "net_api.h"

ssize_t my_write(int d, const void *buf, size_t nbytes)
{
  int i;
  if ((i = write (d, buf, nbytes)) == -1)
  {
    perror ("write");
  }
  return (i);
}

int main (void)
{
  int fd;
  TAddress A = 1, B = 2;
  int len;
  char buf[255];

  fd = open (FILE_NET_SRC, O_RDWR | O_CREAT, 0600);
  if (fd == -1)
  {
    perror ("open");
    exit (EXIT_FAILURE);
  }

  printf("Buffer ?\n");
  scanf ("%s", buf);

  my_write (fd, &A, 1);
  my_write (fd, &B, 1);
  len = strlen (buf);
  my_write (fd, &len, 1);
  my_write (fd, buf, len);

  close (fd);
  printf ("OK !\n");

  return (0);
}
